
TIDB = { }

local function onDragStart(self) self:StartMoving() end

local function onDragStop(self)
	self:StopMovingOrSizing()
	TIDB.x = self:GetLeft()
	TIDB.y = self:GetTop()
end

local function OnDragHandleMouseDown(self) self.frame:StartSizing("BOTTOMRIGHT") end

local function OnDragHandleMouseUp(self, button) self.frame:StopMovingOrSizing() end

local function onResize(self, width, height)
	height = width*1.42
	TIDB.width = width
	TIDB.height = height
	self:SetHeight(height)
	
	local scale = width/300
	
	
	if self.left ~= nil then 
		self.left:SetPoint("TOPLEFT", self, 4*scale, -5*scale)
		self.left:SetHeight(height-9*scale)
		self.left:SetWidth(width/20*12)
		if self.left.text ~= nil then
			local i
			for i=0,table.getn(self.left.text) do
				self.left.text[i]:SetPoint("TOP", "TI.left", 2*scale, (-2 + -15.4*i)*scale)
				if i == 0 then
					self.left.text[i]:SetFont("Fonts\\ARIALN.TTF",12*scale,"OUTLINE")
				else
					self.left.text[i]:SetFont("Fonts\\ARIALN.TTF",12*scale)
				end
			end
		end
		if self.left.icon ~= nil then
			local i
			for i=0,table.getn(self.left.icon) do
				if i == 0 then
					self.left.icon[i]:SetPoint("TOPRIGHT", "TI.left", 6*scale, -3*scale)
					self.left.icon[i]:SetWidth(20*scale)
					self.left.icon[i]:SetHeight(20*scale)
				else
					self.left.icon[i]:SetPoint("TOPRIGHT", "TI.left", -3*scale, (-2 + -15.5*i)*scale)
					self.left.icon[i]:SetWidth(10*scale)
					self.left.icon[i]:SetHeight(10*scale)
				end
			end
		end
		if self.left.settingsicon ~= nil then
			self.left.settingsicon:SetPoint("TOPLEFT", "TI.left", 1*scale, -1*scale)
			self.left.settingsicon:SetWidth(10*scale)
			self.left.settingsicon:SetHeight(10*scale)
		end
		
	end
	if self.mid ~= nil then
		self.mid:SetHeight(height-9*scale)
		self.mid:SetWidth(width/20*4-6*scale)
		self.mid:SetPoint("TOPLEFT", self.left, "TOPRIGHT", 2*scale, 0)
		if self.mid.text ~= nil then
			local i
			for i=0,table.getn(self.mid.text) do
				self.mid.text[i]:SetPoint("TOP", "TI.mid", 2*scale, (-2 + -15.4*i)*scale)
				if i == 0 then
					self.mid.text[i]:SetFont("Fonts\\ARIALN.TTF",12*scale,"OUTLINE")
				else
					self.mid.text[i]:SetFont("Fonts\\ARIALN.TTF",12*scale)
				end
			end
		end
		if self.mid.button ~= nil then
			local i
			for i=0,table.getn(self.mid.button) do
				self.mid.button[i]:SetPoint("TOPLEFT", "TI.mid", 0, -2-(15.4*i)*scale)
				self.mid.button[i]:SetHeight(13*scale)
				self.mid.button[i]:SetWidth(self.mid:GetWidth())
				self.mid.button[i].icon:SetWidth(10*scale)
				self.mid.button[i].icon:SetHeight(10*scale)
			end
		end
	end
	if self.right ~= nil then 
		self.right:SetHeight(height-9*scale) 
		self.right:SetWidth(width/20*4-6*scale)
		self.right:SetPoint("TOPLEFT", self.mid, "TOPRIGHT", 2*scale, 0)
		if self.right.text ~= nil then
			local i
			for i=0,table.getn(self.right.text) do
				self.right.text[i]:SetPoint("TOP", "TI.right", 2*scale, (-2 + -15.4*i)*scale)
				if i == 0 then
					self.right.text[i]:SetFont("Fonts\\ARIALN.TTF",12*scale,"OUTLINE")
				else
					self.right.text[i]:SetFont("Fonts\\ARIALN.TTF",12*scale)
				end
			end
		end
	end
end

--------------------------------

local locked = true
local optshown = false
local RareIDs = {
	73174, -- Archiereus of Flame Sanctuary
	73666, -- Archiereus of Flame Summoned
	72775, -- Bufo
	73171, -- Champion of the Black Flame
	72045, -- Chelon
	73175, -- Cinderfall
	72049, -- Cranegnasher
	73281, -- Dread Ship Vazuvius
	73279, -- Evermaw
	73172, -- Flintlord Gairan
	73282, -- Garnia
	72970, -- Golganarr
	72909, -- Gu'chi the Swarmbringer
	73167, -- Huolon 
	73169, -- Jakur of Ordon
	72193, -- Karkanos
	73277, -- Leafmender
	72048, -- Rattleskew
	73157, -- Rock Moss
	71864, -- Spelurk
	72769, -- Spirit of Jadefire
	73704, -- Stinkbraid 
	72808, -- Tsavo'ka
	73173, -- Urdur the Cauterizer
	73170, -- Watcher Osu
	72245, -- Zesqua
	71919 -- Zhu-Gon the Sour
	--69384  -- Luminescent Crawler - FOR TESTING ONLY
}
local RareCoords = {
	"49.7 / 22.2 (Next to any cauldron within Ordon Sanctuary)", -- Archiereus of Flame
	"34 / 28 (On the Tree-Breeze Terrace)", -- Archiereus of Flame Summoned
	"Around 65 / 70", -- Bufo
	"61.8 / 45.0 (Patrols between the 2 big bridges in Blazing Way)", -- Champion of the Black Flame
	"25.0 / 36.0", -- Chelon
	"54.2 / 53.4 (On Bridge to Ordon Sanctuary)", -- Cinderfall
	"43.8 / 69.8", -- Cranegnasher
	"25.8 / 23.4", -- Dread Ship Vazuvius
	"19 / 72 (Swims Circle around Isle)", -- Evermaw
	"46.5 / 36.7 (Patrols SW side of Ordon Sanctuary)", -- Flintlord Gairan
	"64.8 / 27.2", -- Garnia
	"62.5 / 61.5", -- Golganarr
	"~38 / 77 (Spawns within Old Pi'jiu Village)", -- Gu'chi the Swarmbringer
	"64.6 / 61.4", -- Huolon
	"53.6 / 82.8", -- Jakur of Ordon
	"34.2 / 83.7", -- Karkanos
	"67.6 / 44.0", -- Leafmender
	"61.0 / 88.6", -- Rattleskew
	"43.6 / 30.6 (Inside Cavern of Lost Spirits)", -- Rock Moss
	"59.6 / 48.6 (Inside Mysterious Den)", -- Spelurk
	"~46.6 / 32.8 (Random Location inside Cavern of Lost Spirits)", -- Spirit of Jadefire
	"71.6 / 82.4", -- Stinkbraid
	"54.2 / 42.6", -- Tsavo'ka
	"~44.6 / 25.6", -- Urdur the Cauterizer
	"57.2 / 77.6", -- Watcher Osu
	"47.2 / 87.8", -- Zesqua
	"37.8 / 77.2", -- Zhu-Gon the Sour

}
local RareCoordsRaw = {
	{x=49.7, y=22.2}, -- Archiereus of Flame Sanctuary
	{x=34.9, y=28.9}, -- Archiereus of Flame Summoned
	{x=65.4, y=70.0}, -- Bufo
	{x=61, y=45}, -- Champion of the Black Flame
	{x=25.3, y=35.8}, -- Chelon
	{x=54.0, y=52.4}, -- Cinderfall
	{x=44.5, y=69.0}, -- Cranegnasher
	{x=25.8, y=23.2}, -- Dread Ship Vazuvius
	{x=19, y=72}, -- Evermaw
	{x=46, y=36}, -- Flintlord Gairan
	{x=64.8, y=28.8}, -- Garnia
	{x=62.5, y=63.5}, -- Golganarr
	{x=38, y=77}, -- Gu'chi the Swarmbringer
	{x=64.6, y=61.4}, -- Huolon 
	{x=52.0, y=83.4}, -- Jakur of Ordon
	{x=33.9, y=85.1}, -- Karkanos
	{x=67.3, y=44.1}, -- Leafmender
	{x=60.6, y=87.2}, -- Rattleskew
	{x=45.4, y=29.4}, -- Rock Moss
	{x=59.0, y=48.8}, -- Spelurk
	{x=45.4, y=38.9}, -- Spirit of Jadefire
	{x=71.5, y=80.7}, -- Stinkbraid 
	{x=54.6, y=44.3}, -- Tsavo'ka
	{x=45.4, y=26.6}, -- Urdur the Cauterizer
	{x=57.5, y=77.1}, -- Watcher Osu
	{x=47.6, y=87.3}, -- Zesqua
	{x=37.4, y=77.4} -- Zhu-Gon the Sour
}
local RareNamesLocalized = {};
RareNamesLocalized['enUS'] = {}
RareNamesLocalized['enUS'][73174] = "Archiereus of Flame"
RareNamesLocalized['enUS'][73666] = "Archiereus of Flame"
RareNamesLocalized['enUS'][72775] = "Bufo"
RareNamesLocalized['enUS'][73171] = "Champion of the Black Flame"
RareNamesLocalized['enUS'][72045] = "Chelon"
RareNamesLocalized['enUS'][73175] = "Cinderfall"
RareNamesLocalized['enUS'][72049] = "Cranegnasher"
RareNamesLocalized['enUS'][73281] = "Dread Ship Vazuvius"
RareNamesLocalized['enUS'][73279] = "Evermaw"
RareNamesLocalized['enUS'][73172] = "Flintlord Gairan"
RareNamesLocalized['enUS'][73282] = "Garnia"
RareNamesLocalized['enUS'][72970] = "Golganarr"
RareNamesLocalized['enUS'][72909] = "Gu'chi the Swarmbringer"
RareNamesLocalized['enUS'][73167] = "Huolon "
RareNamesLocalized['enUS'][73169] = "Jakur of Ordon"
RareNamesLocalized['enUS'][72193] = "Karkanos"
RareNamesLocalized['enUS'][73277] = "Leafmender"
RareNamesLocalized['enUS'][72048] = "Rattleskew"
RareNamesLocalized['enUS'][73157] = "Rock Moss"
RareNamesLocalized['enUS'][71864] = "Spelurk"
RareNamesLocalized['enUS'][72769] = "Spirit of Jadefire"
RareNamesLocalized['enUS'][73704] = "Stinkbraid "
RareNamesLocalized['enUS'][72808] = "Tsavo'ka"
RareNamesLocalized['enUS'][73173] = "Urdur the Cauterizer"
RareNamesLocalized['enUS'][73170] = "Watcher Osu"
RareNamesLocalized['enUS'][72245] = "Zesqua"
RareNamesLocalized['enUS'][71919] = "Zhu-Gon the Sour"
--RareNamesLocalized['enUS'][69384] = "Luminescent Crawler"
RareNamesLocalized['deDE'] = {}
RareNamesLocalized['deDE'][73174] = "Archiereus der Flamme"
RareNamesLocalized['deDE'][73666] = "Archiereus der Flamme"
RareNamesLocalized['deDE'][72775] = "Bufo"
RareNamesLocalized['deDE'][73171] = "Champion der Schwarzen Flamme"
RareNamesLocalized['deDE'][72045] = "Chelon"
RareNamesLocalized['deDE'][73175] = "Glutfall"
RareNamesLocalized['deDE'][73854] = "Kranichknirscher"
RareNamesLocalized['deDE'][73281] = "Schreckensschiff Vazuvius"
RareNamesLocalized['deDE'][73158] = "Smaragdkranich"
RareNamesLocalized['deDE'][73279] = "Tiefenschlund"
RareNamesLocalized['deDE'][73172] = "Funkenlord Gairan"
RareNamesLocalized['deDE'][73282] = "Garnia"
RareNamesLocalized['deDE'][72970] = "Golganarr"
RareNamesLocalized['deDE'][73161] = "Großschildkröte Zornpanzer"
RareNamesLocalized['deDE'][72909] = "Gu'chi der Schwarmbringer"
RareNamesLocalized['deDE'][73167] = "Huolon"
RareNamesLocalized['deDE'][73163] = "Kaiserpython"
RareNamesLocalized['deDE'][73160] = "Eisenfellstahlhorn"
RareNamesLocalized['deDE'][73169] = "Jakur von Ordos"
RareNamesLocalized['deDE'][72193] = "Karkanos"
RareNamesLocalized['deDE'][73277] = "Blattheiler"
RareNamesLocalized['deDE'][73166] = "Monströse Dornzange"
RareNamesLocalized['deDE'][72048] = "Klapperknochen"
RareNamesLocalized['deDE'][73157] = "Steinmoos"
RareNamesLocalized['deDE'][71864] = "Spelurk"
RareNamesLocalized['deDE'][72769] = "Jadefeuergeist"
RareNamesLocalized['deDE'][73704] = "Stinkezopf"
RareNamesLocalized['deDE'][72808] = "Tsavo'ka"
RareNamesLocalized['deDE'][73173] = "Urdur der Kauterisierer"
RareNamesLocalized['deDE'][73170] = "Behüter Osu"
RareNamesLocalized['deDE'][72245] = "Zesqua"
RareNamesLocalized['deDE'][71919] = "Zhu-Gon der Saure"
RareNamesLocalized['esES'] = {}
RareNamesLocalized['esES'][73174] = "Sacerdote ilustre de las llamas"
RareNamesLocalized['esES'][73666] = "Sacerdote ilustre de las llamas"
RareNamesLocalized['esES'][72775] = "Buffo"
RareNamesLocalized['esES'][73171] = "Campeón de la Llama Negra"
RareNamesLocalized['esES'][72045] = "Quelón"
RareNamesLocalized['esES'][73175] = "Carbonos"
RareNamesLocalized['esES'][73854] = "Mascagrullas"
RareNamesLocalized['esES'][73281] = "Barco aterrador Vazuvius"
RareNamesLocalized['esES'][73158] = "Ganso esmeralda"
RareNamesLocalized['esES'][73279] = "Fauce Eterna"
RareNamesLocalized['esES'][73172] = "Señor del sílex Gairan"
RareNamesLocalized['esES'][73282] = "Garnia"
RareNamesLocalized['esES'][72970] = "Golganarr"
RareNamesLocalized['esES'][73161] = "Gran tortuga Irazón"
RareNamesLocalized['esES'][72909] = "Gu'chi el Portaenjambres"
RareNamesLocalized['esES'][73167] = "Huolon"
RareNamesLocalized['esES'][73163] = "Pitón imperial"
RareNamesLocalized['esES'][73160] = "Astado acerado Cueracero"
RareNamesLocalized['esES'][73169] = "Jakur el Ordon"
RareNamesLocalized['esES'][72193] = "Karkanos"
RareNamesLocalized['esES'][73277] = "Sanador de hojas"
RareNamesLocalized['esES'][73166] = "Pinzaespina monstruoso"
RareNamesLocalized['esES'][72048] = "Ossotremulus"
RareNamesLocalized['esES'][73157] = "Musgo de roca"
RareNamesLocalized['esES'][71864] = "Espectrante"
RareNamesLocalized['esES'][72769] = "Espíritu de fuego de jade"
RareNamesLocalized['esES'][73704] = "Barbasucia"
RareNamesLocalized['esES'][72808] = "Tsavo'ka"
RareNamesLocalized['esES'][73173] = "Urdur el Cauterizador"
RareNamesLocalized['esES'][73170] = "Vigía Osu"
RareNamesLocalized['esES'][72245] = "Zesqua"
RareNamesLocalized['esES'][71919] = "Zhu Gon el Agrio"
RareNamesLocalized['frFR'] = {}
RareNamesLocalized['frFR'][73174] = "Archiprêtre de flammes"
RareNamesLocalized['frFR'][73666] = "Archiprêtre de flammes"
RareNamesLocalized['frFR'][72775] = "Bufo"
RareNamesLocalized['frFR'][73171] = "Champion de la flamme noire"
RareNamesLocalized['frFR'][72045] = "Chelon"
RareNamesLocalized['frFR'][73175] = "Cendrechute"
RareNamesLocalized['frFR'][73854] = "Croque-grue"
RareNamesLocalized['frFR'][73281] = "Bateau de l’effroi Vazuvius"
RareNamesLocalized['frFR'][73158] = "Jars émeraude"
RareNamesLocalized['frFR'][73279] = "Gueule-Éternelle"
RareNamesLocalized['frFR'][73172] = "Seigneur des silex Gairan"
RareNamesLocalized['frFR'][73282] = "Garnia"
RareNamesLocalized['frFR'][72970] = "Golganarr"
RareNamesLocalized['frFR'][73161] = "Grande tortue Écaille-de-Fureur"
RareNamesLocalized['frFR'][72909] = "Gu’chi l’Essaimeur"
RareNamesLocalized['frFR'][73167] = "Huolon"
RareNamesLocalized['frFR'][73163] = "Python impérial"
RareNamesLocalized['frFR'][73160] = "Corne-d’acier ferpoil"
RareNamesLocalized['frFR'][73169] = "Jakur d’Ordos"
RareNamesLocalized['frFR'][72193] = "Karkanos"
RareNamesLocalized['frFR'][73277] = "Soigne-Feuille"
RareNamesLocalized['frFR'][73166] = "Pincépine monstrueux"
RareNamesLocalized['frFR'][72048] = "Déglingois"
RareNamesLocalized['frFR'][73157] = "Mousse des rochers"
RareNamesLocalized['frFR'][71864] = "Souterrant"
RareNamesLocalized['frFR'][72769] = "Esprit de Jadefeu"
RareNamesLocalized['frFR'][73704] = "Fouettnatte"
RareNamesLocalized['frFR'][72808] = "Tsavo’ka"
RareNamesLocalized['frFR'][73173] = "Urdur le Cautérisateur"
RareNamesLocalized['frFR'][73170] = "Guetteur Osu"
RareNamesLocalized['frFR'][72245] = "Zesqua"
RareNamesLocalized['frFR'][71919] = "Zhu Gon l’Amer"
RareNamesLocalized['ruRU'] = {}
RareNamesLocalized['ruRU'][72775] = "Буфо"
RareNamesLocalized['ruRU'][72909] = "Гу'чи Зовущий Рой"
RareNamesLocalized['ruRU'][73277] = "Целитель листвы"
RareNamesLocalized['ruRU'][72049] = "Журавлецап"
RareNamesLocalized['ruRU'][72048] = "Косохрип"
RareNamesLocalized['ruRU'][71864] = "Чароброд"
RareNamesLocalized['ruRU'][73157] = "Пещерный Мох"
RareNamesLocalized['ruRU'][73170] = "Смотритель Осу"
RareNamesLocalized['ruRU'][73174] = "Архиерей пламени"
RareNamesLocalized['ruRU'][73666] = "Архиерей пламени"
RareNamesLocalized['ruRU'][73281] = "Проклятый корабль Вазувий"
RareNamesLocalized['ruRU'][71919] = "Чжу-Гонь Прокисший"
RareNamesLocalized['ruRU'][72193] = "Карканос"
RareNamesLocalized['ruRU'][72808] = "Тсаво'ка"
RareNamesLocalized['ruRU'][73171] = "Защитник Черного Пламени"
RareNamesLocalized['ruRU'][73175] = "Пеплопад"
RareNamesLocalized['ruRU'][73282] = "Гарния"
RareNamesLocalized['ruRU'][72045] = "Шелон"
RareNamesLocalized['ruRU'][72245] = "Зесква"
RareNamesLocalized['ruRU'][73167] = "Холон"
RareNamesLocalized['ruRU'][73172] = "Повелитель кремня Гайран"
RareNamesLocalized['ruRU'][72769] = "Дух Нефритового Пламени"
RareNamesLocalized['ruRU'][72970] = "Голганарр"
RareNamesLocalized['ruRU'][73169] = "Якур Ордосский"
RareNamesLocalized['ruRU'][73173] = "Урдур Прижигатель"
RareNamesLocalized['ruRU'][73279] = "Вечножор"
RareNamesLocalized['ruRU'][73704] = "Вонекос"

local SoundsToPlay = {}
SoundsToPlay['none'] = ""
SoundsToPlay['DIIING'] = "sound\\CREATURE\\MANDOKIR\\VO_ZG2_MANDOKIR_LEVELUP_EVENT_01.ogg"
SoundsToPlay['You are not prepared!'] = "sound\\Creature\\Illidan\\BLACK_Illidan_04.wav"


local RareSeen = {}
local RareKilled = {}
local RareAlive = {}
local RareAliveHP = {}
local RareAnnounced = {}
local RareAnnouncedSelf = {}
local LastSent = {}
local RareAv = {}
local SoundPlayed = {}

--local SoundPlayed = 0
local VersionNotify = false
local myChan = false

local txt = ""
local currentWaypointX = false
local currentWaypointY = false
local currentWaypointNPCID = false

local needStatus = false

--------------------------------
local TI = CreateFrame("Frame", "TI", UIParent)
TI.version = "v5.4.0-5"


function TI:getLocalRareName(id)
	if RareNamesLocalized[GetLocale()] ~= nil then
		if RareNamesLocalized[GetLocale()][id] ~= nil then
			return RareNamesLocalized[GetLocale()][id]
		end
	end
	if RareNamesLocalized['enUS'][id] ~= nil then
		return RareNamesLocalized['enUS'][id]
	else
		return "Unknown Name"
	end
end

function TI:getTargetPercentHP()
	local currhp = UnitHealth("target")
	local maxhp = UnitHealthMax("target")
	if currhp == 0 and maxhp == 0 then
		return false
	else
		return math.floor(currhp/maxhp * 100) 
	end
end

function TI:getTargetPercentHProunded()
	local per = self:getTargetPercentHP()
	if per then
		return math.floor(per/10)*10
	else
		return false
	end
end

function TI:setWaypoint(id)
	if TomTom ~= nil then
		if currentWaypointX == false and currentWaypointY == false then
			if RareCoordsRaw[id]["x"] ~= 0 and RareCoordsRaw[id]["y"] ~= 0 then
				TomTom:AddWaypoint(RareCoordsRaw[id]["x"],RareCoordsRaw[id]["y"],self:getLocalRareName(RareIDs[id]))
				currentWaypointX = RareCoordsRaw[id]["x"]
				currentWaypointY = RareCoordsRaw[id]["y"]
				currentWaypointNPCID = RareIDs[id]
			end
		end
	end
end

local function OnMouseDownAnnounce(id)
	if RareAnnounced[RareIDs[id]] == nil then
		if RareAliveHP[RareIDs[id]] == nil then
			SendChatMessage("{rt1} [TIRareCoordinator] "..TI:getLocalRareName(RareIDs[id])..": "..RareCoords[id].." {rt1}", "CHANNEL", nil, 1)
		else
			SendChatMessage("{rt1} [TIRareCoordinator] "..TI:getLocalRareName(RareIDs[id]).."("..RareAliveHP[RareIDs[id]].."%): "..RareCoords[id].." {rt1}", "CHANNEL", nil, 1)
		end
		SendChatMessage("[RCELVA]"..TI.version.."_"..RareIDs[id].."_announce_"..time().."_", "CHANNEL", nil, TI:getChanID(GetChannelList()))
		RareAnnounced[RareIDs[id]] = time()
		RareAnnouncedSelf[RareIDs[id]] = time()
	end
end

function OptShowOrHide()
	if optshown then
		TI.opt:Hide()
		optshown = false
	else
		TI.opt:Show()
		UIDropDownMenu_SetText(TI.opt.sound.dropdown, TIDB.sound)
		if locked then
			TI.opt.locked.status:SetText("Frame is |cffff0000locked")
			TI.opt.locked.button:SetText("unlock")
		else
			TI.opt.locked.status:SetText("Frame is |cff00ff00unlocked")
			TI.opt.locked.button:SetText("lock")
		end
		optshown = true
	end
end

TI:SetWidth(300)
TI:SetHeight(200)
TI:SetFrameStrata("BACKGROUND")
TI:SetPoint("CENTER",0,0)
TI:SetClampedToScreen(true)
TI:SetMinResize(150, 0)
TI:SetMaxResize(500, 0)

TI.texture = TI:CreateTexture(nil,"BACKGROUND")
TI.texture:SetTexture(0,0,0,0.4)
TI.texture:SetAllPoints(TI)


TI.left = CreateFrame("Frame", "TI.left", TI)
TI.left:SetWidth(200)
TI.left:SetHeight(TI:GetHeight()-9)
TI.left:SetPoint("TOPLEFT", TI, 5, -5)
TI.left.texture = TI:CreateTexture(nil,"BACKGROUND", nil, 1)
TI.left.texture:SetTexture(0,0,0,0.2)
TI.left.texture:SetAllPoints(TI.left)

TI.mid = CreateFrame("Frame", "TI.mid", TI)
TI.mid:SetWidth(80)
TI.mid:SetHeight(TI:GetHeight()-9)
TI.mid:SetPoint("TOPLEFT", TI.left, "TOPRIGHT", 2, 0)
TI.mid.texture = TI:CreateTexture(nil,"BACKGROUND", nil, 1)
TI.mid.texture:SetTexture(0,0,0,0.2)
TI.mid.texture:SetAllPoints(TI.mid)

TI.right = CreateFrame("Frame", "TI.right", TI)
TI.right:SetWidth(80)
TI.right:SetHeight(TI:GetHeight()-9)
TI.right:SetPoint("TOPLEFT", TI.mid, "TOPRIGHT", 2, 0)
TI.right.texture = TI:CreateTexture(nil,"BACKGROUND", nil, 1)
TI.right.texture:SetTexture(0,0,0,0.2)
TI.right.texture:SetAllPoints(TI.right)

TI.res = CreateFrame("Frame", "TI.res", TI)
TI.res.frame = TI
TI.res:SetWidth(16)
TI.res:SetHeight(16)
TI.res:SetPoint("BOTTOMRIGHT", TI, -1, 1)
TI.res:EnableMouse(true)
TI.res:SetScript("OnMouseDown", OnDragHandleMouseDown)
TI.res:SetScript("OnMouseUp", OnDragHandleMouseUp)
TI.res:SetAlpha(0.5)

TI.res.texture = TI.res:CreateTexture(nil, "OVERLAY")
TI.res.texture:SetTexture([[Interface\AddOns\TIRareCoordinator\resize.tga]])
TI.res.texture:SetWidth(16)
TI.res.texture:SetHeight(16)
TI.res.texture:SetBlendMode("ADD")
TI.res.texture:SetPoint("CENTER", TI.res)

TI.res:Hide()


TI.left.text = {}
local i
for i=0, #RareIDs do
	TI.left.text[i] = TI.left:CreateFontString("TI.left.text["..i.."]", nil, "GameFontNormal")
	TI.left.text[i]:SetPoint("TOP", "TI.left", 2, -2 + -14.5*i)
	TI.left.text[i]:SetFont("Fonts\\ARIALN.TTF",12)
	TI.left.text[i]:SetTextColor(1,1,1)
	if i == 0 then
		TI.left.text[i]:SetText("Rare")
		TI.left.text[i]:SetFont("Fonts\\ARIALN.TTF",12,"OUTLINE")
	else
		TI.left.text[i]:SetText(TI:getLocalRareName(RareIDs[i]))
	end
end
TI.left.icon = {}
local i
for i=0, #RareIDs do
	TI.left.icon[i] = CreateFrame("Frame", "TI.left.icon["..i.."]", TI)

	if i == 0 then
		TI.left.icon[i]:SetPoint("TOPRIGHT", "TI.left", 6, -5)
		TI.left.icon[i]:SetWidth(20)
		TI.left.icon[i]:SetHeight(20)
		TI.left.icon[i].texture = TI.left.icon[i]:CreateTexture(nil, "OVERLAY")
		TI.left.icon[i].texture:SetTexture([[Interface\ACHIEVEMENTFRAME\UI-Achievement-TinyShield]])
		TI.left.icon[i].texture:SetAllPoints(TI.left.icon[i])
	else
		TI.left.icon[i]:SetPoint("TOPRIGHT", "TI.left", -3, -3 + -14.8*i)
		TI.left.icon[i]:SetWidth(10)
		TI.left.icon[i]:SetHeight(10)
		TI.left.icon[i].texture = TI.left.icon[i]:CreateTexture(nil, "OVERLAY")
		TI.left.icon[i].texture:SetAllPoints(TI.left.icon[i])
	end
end

TI.left.settingsicon = CreateFrame("Frame", "TI.left.settingsicon", TI)
TI.left.settingsicon:SetPoint("TOPLEFT", "TI.left", 6, -5)
TI.left.settingsicon:SetWidth(10)
TI.left.settingsicon:SetHeight(10)
TI.left.settingsicon.texture = TI.left.settingsicon:CreateTexture(nil, "OVERLAY")
TI.left.settingsicon.texture:SetTexture([[Interface\AddOns\TIRareCoordinator\settings.tga]])
TI.left.settingsicon.texture:SetAllPoints(TI.left.settingsicon)

TI.mid.button = {}
for i=0, #RareIDs do
	TI.mid.button[i] = CreateFrame("Frame", "TI.mid.button["..i.."]", TI)
	TI.mid.button[i]:SetPoint("TOPLEFT", "TI.mid", 0, -2 + -14.5*i)
	TI.mid.button[i]:SetHeight(13)
	TI.mid.button[i]:SetWidth(TI.mid:GetWidth())
	TI.mid.button[i].texture = TI.mid.button[i]:CreateTexture(nil,"BACKGROUND", nil, 2)
	TI.mid.button[i].texture:SetTexture(0,0.5,0,0.4)
	TI.mid.button[i].texture:SetAllPoints(TI.mid.button[i])
	
	TI.mid.button[i].icon = CreateFrame("Frame", "TI.mid.icon["..i.."].icon", TI.mid.button[i])
	TI.mid.button[i].icon:SetPoint("RIGHT", "TI.mid.button["..i.."]", 2, 0)
	TI.mid.button[i].icon:SetWidth(10)
	TI.mid.button[i].icon:SetHeight(10)
	TI.mid.button[i].icon.texture = TI.mid.button[i].icon:CreateTexture(nil, "OVERLAY")
	TI.mid.button[i].icon.texture:SetTexture([[Interface\AddOns\TIRareCoordinator\announce.tga]])
	TI.mid.button[i].icon.texture:SetAllPoints(TI.mid.button[i].icon)
	if i ~= 0 then
		TI.mid.button[i]:SetScript("OnMouseDown", function (self) OnMouseDownAnnounce(i) end)
	end
	TI.mid.button[i]:Hide()
end
TI.mid.text = {}
local i
for i=0, #RareIDs do
	TI.mid.text[i] = TI.mid:CreateFontString("TI.mid.text["..i.."]", nil, "GameFontNormal")
	TI.mid.text[i]:SetPoint("TOP", "TI.mid", 2, -2 + -14.5*i)
	TI.mid.text[i]:SetFont("Fonts\\ARIALN.TTF",12)
	TI.mid.text[i]:SetTextColor(1,1,1)
	if i == 0 then
		TI.mid.text[i]:SetText("Seen")
		TI.mid.text[i]:SetFont("Fonts\\ARIALN.TTF",12,"OUTLINE")
	end
end
TI.right.text = {}
local i
for i=0, #RareIDs do
	TI.right.text[i] = TI.right:CreateFontString("TI.right.text["..i.."]", nil, "GameFontNormal")
	TI.right.text[i]:SetPoint("TOP", "TI.right", 2, -2 + -14.5*i)
	TI.right.text[i]:SetFont("Fonts\\ARIALN.TTF",12)
	TI.right.text[i]:SetTextColor(1,1,1)
	if i == 0 then
		TI.right.text[i]:SetText("Killed")
		TI.right.text[i]:SetFont("Fonts\\ARIALN.TTF",12,"OUTLINE")
	end
end

TI.opt = CreateFrame("Frame", "TI.opt", TI)
TI.opt:SetWidth(200)
TI.opt:SetHeight(87)
TI.opt:SetPoint("TOPLEFT", TI, "TOPRIGHT", 1, 0)
TI.opt.texture = TI.opt:CreateTexture(nil,"BACKGROUND", nil, 1)
TI.opt.texture:SetTexture(0,0,0,0.4)
TI.opt.texture:SetAllPoints(TI.opt)

TI.opt.locked = CreateFrame("Frame", "TI.opt.locked", TI.opt)
TI.opt.locked:SetWidth(TI.opt:GetWidth() - 8)
TI.opt.locked:SetHeight(20)
TI.opt.locked:SetPoint("TOPLEFT", TI.opt, 4, -4)
TI.opt.locked.texture = TI.opt.locked:CreateTexture(nil,"BACKGROUND", nil, 1)
TI.opt.locked.texture:SetTexture(0,0,0,0.2)
TI.opt.locked.texture:SetAllPoints(TI.opt.locked)

TI.opt.locked.status = TI.opt.locked:CreateFontString("TI.opt.locked.status", nil, "GameFontNormal")
TI.opt.locked.status:SetPoint("LEFT", "TI.opt.locked", 4, 0)
TI.opt.locked.status:SetFont("Fonts\\ARIALN.TTF",12)
TI.opt.locked.status:SetTextColor(1,1,1)
TI.opt.locked.status:SetText("Frame is")

TI.opt.locked.button = CreateFrame("Button", "TI.opt.locked.button", TI.opt.locked, "UIPanelButtonTemplate")
TI.opt.locked.button:SetPoint("RIGHT",-4,0)
TI.opt.locked.button:SetWidth(80)
TI.opt.locked.button:SetHeight(16)
TI.opt.locked.button:SetText("lock")

TI.opt.sound = CreateFrame("Frame", "TI.opt.sound", TI.opt)
TI.opt.sound:SetWidth(TI.opt:GetWidth() - 8)
TI.opt.sound:SetHeight(55)
TI.opt.sound:SetPoint("TOPLEFT", TI.opt.locked, "BOTTOMLEFT", 0, -4)
TI.opt.sound.texture = TI.opt.sound:CreateTexture(nil,"BACKGROUND", nil, 1)
TI.opt.sound.texture:SetTexture(0,0,0,0.2)
TI.opt.sound.texture:SetAllPoints(TI.opt.sound)

TI.opt.sound.caption = TI.opt.sound:CreateFontString("TI.opt.sound.caption", nil, "GameFontNormal")
TI.opt.sound.caption:SetPoint("TOPLEFT", "TI.opt.sound", 4, -4)
TI.opt.sound.caption:SetFont("Fonts\\ARIALN.TTF",12)
TI.opt.sound.caption:SetTextColor(1,1,1)
TI.opt.sound.caption:SetText("Sound to play when a rare is found")

TI.opt.sound.dropdown = CreateFrame("Frame", "TI.opt.sound.dropdown", TI.opt.sound, "UIDropDownMenuTemplate")
TI.opt.sound.dropdown:SetPoint("TOPLEFT", "TI.opt.sound", -8, -21)
UIDropDownMenu_SetWidth(TI.opt.sound.dropdown, 160) 
UIDropDownMenu_Initialize(TI.opt.sound.dropdown,function(self)
	local info = UIDropDownMenu_CreateInfo()
	local i = 0
	for k,v in pairs(SoundsToPlay) do
		info.text = k
		info.arg1 = k
		info.func = self.SetValue
		UIDropDownMenu_AddButton(info)
		i = i + 1
	end
end)

function TI.opt.sound.dropdown:SetValue(newValue)
	UIDropDownMenu_SetText(TI.opt.sound.dropdown, newValue)
	TIDB.sound = newValue
	PlaySoundFile(SoundsToPlay[newValue], "master")
end

TI.opt:Hide()

TI.left.settingsicon:SetScript("OnMouseDown", function (self) OptShowOrHide() end)

local total = 0
local function updateText(self,elapsed)
	if elapsed == nil then elapsed = 0 end
    total = total + elapsed
    if total >= 10 then
		for i=1,GetAchievementNumCriteria(8714) do
			_, _, completed, _, _, _, _, assetID, _, _ = GetAchievementCriteriaInfo(8714,i)
			if completed then
				RareAv[assetID] = true
			else
				RareAv[assetID] = false
			end		
		end
		for k,v in pairs(RareSeen) do
			if tonumber(v)+2*60*60 < time() then
				RareSeen[k] = nil
			end
		end
		for k,v in pairs(RareKilled) do
			if tonumber(v)+2*60*60 < time() then
				RareKilled[k] = nil
			end
		end
		for k,v in pairs(RareAlive) do
			if tonumber(v)+10*60 < time() then
				RareAlive[k] = nil
				RareAliveHP[k] = nil
			end
		end
		if TI.left ~= nil then
			if TI.left.icon ~= nil then
				local i
				for i=1,table.getn(TI.left.icon) do
					if RareAv[RareIDs[i]] ~= nil then
						if RareAv[RareIDs[i]] then
							TI.left.icon[i].texture:SetTexture([[Interface\AddOns\TIRareCoordinator\green.tga]])
						else
							TI.left.icon[i].texture:SetTexture([[Interface\AddOns\TIRareCoordinator\red.tga]])
						end
					end
				end
			end
		end
		if TI.mid ~= nil then
			if TI.mid.text ~= nil then
				local i
				for i=1,table.getn(TI.mid.text) do
					if RareAlive[RareIDs[i]] ~= nil then
						if SoundPlayed[RareIDs[i]] == nil then
							PlaySoundFile(SoundsToPlay[TIDB.sound], "MASTER")
							SoundPlayed[RareIDs[i]] = time()
						elseif time() > SoundPlayed[RareIDs[i]] + 600 then
							PlaySoundFile(SoundsToPlay[TIDB.sound], "MASTER")
							SoundPlayed[RareIDs[i]] = time()
						end
						TI.mid.button[i]:Show()
						TI.mid.text[i]:SetText("|cff00ff00alive|r")
						TI:setWaypoint(i)
					elseif RareSeen[RareIDs[i]] ~= nil then
						TI.mid.button[i]:Hide()
						TI.mid.text[i]:SetText(math.floor((time()-RareSeen[RareIDs[i]])/60).."m ago")
					else
						TI.mid.button[i]:Hide()
						TI.mid.text[i]:SetText("never")
					end
				end
			end
		end
		if TI.right ~= nil then
			if TI.right.text ~= nil then
				local i
				for i=1,table.getn(TI.right.text) do
					if RareAliveHP[RareIDs[i]] ~= nil and RareAlive[RareIDs[i]] then
						TI.right.text[i]:SetText("|cff00ff00"..RareAliveHP[RareIDs[i]].."%|r")
					elseif RareKilled[RareIDs[i]] ~= nil then
						TI.right.text[i]:SetText(math.floor((time()-RareKilled[RareIDs[i]])/60).."m ago")
					else
						TI.right.text[i]:SetText("never")
					end
				end
			end
		end
        total = 0
    end
end




function TI:OnEvent(event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		self:CombatLog(...)
	end
	if event == "PLAYER_TARGET_CHANGED" then
		self:Target(...)
	end
	if event == "CHAT_MSG_CHANNEL" then
		self:Chat(...)
	end
	if event == "ADDON_LOADED" then
		self:OnLoad(...)
		self:ShowOrHide(...)
	end
	if event == "ZONE_CHANGED_NEW_AREA" or event == "PLAYER_ENTERING_WORLD" then
		self:ShowOrHide(...)
	end
	if event == "CHAT_MSG_ADDON" then
		self:AddonMsg(...)
	end
	if event == "CHANNEL_ROSTER_UPDATE" then
		self:ChanRosterUpdate(...)
	end
	if event == "UNIT_HEALTH" then
		self:UnitHealth(...)
	end
end

function TI:OnLoad(...)
	if select(1, ...) == "TIRareCoordinator" then
		print("TIRareCoordinator loaded - type /tirc or /tirare for options");
		if TIDB.x == nil or TIDB.y == nil then
			self:SetPoint("CENTER",0,0)
		else
			self:ClearAllPoints()
			self:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", TIDB.x, TIDB.y)
		end
		if TIDB.sound == nil then
			TIDB.sound = "DIIING"
		end
	end
end

function TI:UnitHealth(unit)
	if unit ~= "target" then return end
	if UnitGUID("target") ~= nil then
		id = tonumber(UnitGUID("target"):sub(6, 10), 16)
		for _,v in pairs(RareIDs) do
			if v == id then
				local per = self:getTargetPercentHProunded()
				if per and per >= 0 then
					if RareAliveHP[id] ~= nil then
						if RareAliveHP[id] > per then
							SendChatMessage("[RCELVA]"..self.version.."_"..id.."_alive"..per.."_"..time().."_", "CHANNEL", nil, self:getChanID(GetChannelList()))
							RareAliveHP[id] = per
							updateText(self, 100)
						end
					else
						SendChatMessage("[RCELVA]"..self.version.."_"..id.."_alive"..per.."_"..time().."_", "CHANNEL", nil, self:getChanID(GetChannelList()))
						RareAliveHP[id] = per
						updateText(self, 100)
					end
				end
			end
		end
	end
end

--894
function TI:ShowOrHide(...)
	local zone = GetZoneText()
	if GetCurrentMapAreaID() == 951 then
		RareAlive = {}
		self:Show()
		myChan = false
		self:SetScript("OnUpdate", TI.join)
		self:RegisterEvent("UNIT_HEALTH")
		RegisterAddonMessagePrefix("RCELVA")
	else
		self:Hide()
		LeaveChannelByName("RCELVA")
		self:UnregisterEvent("UNIT_HEALTH")
	end
end




function TI:Chat(message, sender, language, channelString, target, flags, unknown, channelNumber, channelName, unknown, counter, guid)
	if channelName == "RCELVA" then
		if string.find(message, "[RCELVA]") then
			count = 0
			for match in string.gmatch(message, "_") do count = count + 1 end
			if count == 4 then
				message = string.sub(message, 9)
				local eventVersion,eventRareID,eventType,eventTime
				
				firstSeperator,_ = string.find(message, "_")
				if firstSeperator ~= nil then
					eventVersion = string.sub(message, 0, firstSeperator-1)
					message = string.sub(message, firstSeperator+1)
				end
				
				secondSeperator,_ = string.find(message, "_")
				if secondSeperator ~= nil then
					eventRareID = tonumber(string.sub(message, 0, secondSeperator-1))
					message = string.sub(message, secondSeperator+1)
				end
				
				thirdSeperator,_ = string.find(message, "_")
				if thirdSeperator ~= nil then
					eventType = string.sub(message, 0, thirdSeperator-1)
					message = string.sub(message, thirdSeperator+1)
				end
				
				fourthSeperator,_ = string.find(message, "_")
				if firstSeperator ~= nil then
					eventTime = string.sub(message, 0, fourthSeperator-1)
					message = string.sub(message, fourthSeperator+1)
				end
				
				for _,v in pairs(RareIDs) do
					if v == eventRareID and eventType ~= nil and eventTime ~= nil then
						if eventType == "alive" then
							RareAlive[v] = eventTime
						elseif string.sub(eventType,0,5) == "alive" then
							RareAlive[v] = eventTime
							RareAliveHP[v] = tonumber(string.sub(eventType,6))
						elseif eventType == "dead" then
							RareAlive[v] = nil
							RareAliveHP[v] = nil
							if currentWaypointNPCID ~= nil then
								if currentWaypointNPCID == v then
									currentWaypointX = false
									currentWaypointY = false
								end
							end
						elseif eventType == "killed" then
							RareKilled[v] = eventTime
							RareAlive[v] = nil
							RareAliveHP[v] = nil
							if currentWaypointNPCID ~= nil then
								if currentWaypointNPCID == v then
									currentWaypointX = false
									currentWaypointY = false
								end
							end
						elseif eventType == "seen" then
							RareSeen[v] = eventTime
						elseif eventType == "announce" then
							RareAnnounced[v] = eventTime
						end
						updateText(self, 100)
						self:CompareVersion(eventVersion)
						break
					end
				end
			end
		end
	end
end

function TI:AddonMsg(prefix, message, channel, sender)
	--print(prefix.." - "..channel.." - "..sender.."-"..message)
	if prefix == "RCELVA" then
		if channel == "WHISPER" and message == "GetStatus" then
			for id,timestamp in pairs(RareSeen) do
				SendAddonMessage("RCELVA", self.version.."_"..id.."_seen_"..timestamp.."_", "WHISPER", sender)
			end
			for id,timestamp in pairs(RareKilled) do
				SendAddonMessage("RCELVA", self.version.."_"..id.."_killed_"..timestamp.."_", "WHISPER", sender)
			end
			for id,timestamp in pairs(RareAlive) do
				SendAddonMessage("RCELVA", self.version.."_"..id.."_alive_"..timestamp.."_", "WHISPER", sender)
			end
		end
		if channel == "WHISPER" then
			count = 0
			for match in string.gmatch(message, "_") do count = count + 1 end
			if count == 4 then
				firstSeperator,_ = string.find(message, "_")
				if firstSeperator ~= nil then
					eventVersion = string.sub(message, 0, firstSeperator-1)
					message = string.sub(message, firstSeperator+1)
				end
				
				secondSeperator,_ = string.find(message, "_")
				if secondSeperator ~= nil then
					eventRareID = tonumber(string.sub(message, 0, secondSeperator-1))
					message = string.sub(message, secondSeperator+1)
				end
				
				thirdSeperator,_ = string.find(message, "_")
				if thirdSeperator ~= nil then
					eventType = string.sub(message, 0, thirdSeperator-1)
					message = string.sub(message, thirdSeperator+1)
				end
				
				fourthSeperator,_ = string.find(message, "_")
				if firstSeperator ~= nil then
					eventTime = string.sub(message, 0, fourthSeperator-1)
					message = string.sub(message, fourthSeperator+1)
				end
				
				for _,v in pairs(RareIDs) do
					if v == eventRareID and eventType ~= nil and eventTime ~= nil then
						if eventType == "alive" then
							RareAlive[v] = eventTime
						elseif eventType == "dead" then
							RareAlive[v] = nil
							RareAliveHP[v] = nil
						elseif eventType == "killed" then
							RareKilled[v] = eventTime
							RareAlive[v] = nil
							RareAliveHP[v] = nil
						elseif eventType == "seen" then
							RareSeen[v] = eventTime
						end
						updateText(self, 100)
						self:CompareVersion(eventVersion)
						break
					end
				end
				needStatus = false
			end
		end
	end
end

function TI:CompareVersion(v)
	local i=0
	local newVersion=false
	local expan1, cpatch1, mpatch1, revision1, expan2, cpatch2, mpatch2, revision2
	for n in string.gmatch(self.version, "%d+") do
		if     i == 0 then expan1 = tonumber(n)
		elseif i == 1 then cpatch1 = tonumber(n)
		elseif i == 2 then mpatch1 = tonumber(n)
		elseif i == 3 then revision1 = tonumber(n)
		end
		i = i + 1
	end
	i=0
	for n in string.gmatch(v, "%d+") do
		if     i == 0 then expan2 = tonumber(n)
		elseif i == 1 then cpatch2 = tonumber(n)
		elseif i == 2 then mpatch2 = tonumber(n)
		elseif i == 3 then revision2 = tonumber(n)
		end
		i = i + 1
	end
	if expan2 > expan1 then
		newVersion = true
	elseif cpatch2 > cpatch1 then
		newVersion = true
	elseif mpatch2 > mpatch1 then
		newVersion = true
	elseif revision2 > revision1 then
		newVersion = true
	end
	if newVersion and VersionNotify == false then
--		print("TIRareCoordinator - New Version available: |cff00ff00"..v.."|r (You are using |cffff0000"..TI.version.."|r)")
		VersionNotify = true
	end
end

--3/8 18:03:12.537 UNIT_DIED,0x0000000000000000,nil,        0x80000000,  0x80000000,0xF13108BC0004C67E,"Creeping Moor Beast",0x10a48,0x0
function TI:CombatLog(timeStamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, ...)
	if event == "UNIT_DIED" then
		for _,v in pairs(RareIDs) do
			local npcID = tonumber(destGUID:sub(6, 10), 16)
			if v == npcID then
					msg = time() .. " Rare Mob killed: " .. v
					RareKilled[v] = time()
					--self:DebugMsg(msg)
					SendChatMessage("[RCELVA]"..self.version.."_"..npcID.."_killed_"..time().."_", "CHANNEL", nil, self:getChanID(GetChannelList()))
					RareAlive[v] = nil
					RareAliveHP[v] = nil
					SendChatMessage("[RCELVA]"..self.version.."_"..npcID.."_dead_"..time().."_", "CHANNEL", nil, self:getChanID(GetChannelList()))
					if RareAnnouncedSelf[v] then
						SendChatMessage("{rt8} [TIRareCoordinator] "..TI:getLocalRareName(npcID).." is now dead {rt8}", "CHANNEL", nil, 1)
						RareAnnouncedSelf[v] = nil						
						RareAnnounced[v] = nil
					end
					if currentWaypointNPCID ~= nil then
						if currentWaypointNPCID == npcID then
							currentWaypointX = false
							currentWaypointY = false
						end
					end
					updateText(self, 100)
				break
			end
		end
	end
end

function TI:ChanRosterUpdate(id)
	if needStatus == true then
		--print ("roster update: ".. id)
		--print (GetChannelDisplayInfo(id))
		local name, header, collapsed, channelNumber, count, active, category, voiceEnabled, voiceActive = GetChannelDisplayInfo(id)
		if name == "RCELVA" then
			self:SetScript("OnUpdate", nil)
			--print("Got displayId of "..name..": "..id)
			
			local count = select(5, GetChannelDisplayInfo(id))
			--print("count"..count)
			for i=1,count do
				local name = select(1, GetChannelRosterInfo(id, i))
				local owner = select(2, GetChannelRosterInfo(id, i))
				if owner then
					--print(name .." is the owner right now")
					SendAddonMessage("RCELVA", "GetStatus", "WHISPER", name)
					updateText(self, 100)
				end
			end
		end
	end
end

function TI:getChanID(...)
	if myChan ~= false then
		return myChan
	end
	local gotID = false
	for i = 1, select("#", ...), 2 do
		local id, name = select(i, ...)
		if name == "RCELVA" then
			gotID = true
			myChan = id
			return id
		end
	end
	if gotID == false then
		return false
	end
end

function TI:getChanDisplayID()
	local channels = GetNumDisplayChannels()
	local i = 1 
	
	while i <= channels do
		SetSelectedDisplayChannel(i)
		local name, header, collapsed, channelNumber, count, active, category, voiceEnabled, voiceActive = GetChannelDisplayInfo(i)
		if name == "RCELVA" then
			--print("Got displayId of "..name..": "..i)
			return i
		end
		i = i + 1
	end
end

function TI:getChanOwner()
	local id = self:getChanDisplayID()
	if id ~= nil then
		SetSelectedDisplayChannel(id)
		local count = select(5, GetChannelDisplayInfo(id))
		--print("count"..count)
		for i=1,count do
			local name = select(1, GetChannelRosterInfo(id, i))
			local owner = select(2, GetChannelRosterInfo(id, i))
			if owner then
				return name
			end
		end
	end
end

function TI:Target(...)
--/run print(("NPC ID of %s: %d"):format(UnitName("target"), tonumber(UnitGUID("target"):sub(6, 10), 16)))
	if UnitGUID("target") ~= nil then
		id = tonumber(UnitGUID("target"):sub(6, 10), 16)
		for _,v in pairs(RareIDs) do
			if v == id then
					msg = time() .. " Rare Mob targeted: " .. id
					if UnitHealth("target") > 0 then
						RareAlive[v] = time()
						SendChatMessage("[RCELVA]"..self.version.."_"..id.."_alive_"..time().."_", "CHANNEL", nil, self:getChanID(GetChannelList()))
					else
						RareAlive[v] = nil
						RareAliveHP[v] = nil
						if currentWaypointNPCID ~= nil then
							if currentWaypointNPCID == id then
								currentWaypointX = false
								currentWaypointY = false
							end
						end
						SendChatMessage("[RCELVA]"..self.version.."_"..id.."_dead_"..time().."_", "CHANNEL", nil, self:getChanID(GetChannelList()))
					end
					RareSeen[v] = time()
					if LastSent[v] == nil then
						SendChatMessage("[RCELVA]"..self.version.."_"..id.."_seen_"..time().."_", "CHANNEL", nil, self:getChanID(GetChannelList()))
						LastSent[v] = time()
					else
						if (LastSent[v] + 30) < time() then
							SendChatMessage("[RCELVA]"..self.version.."_"..id.."_seen_"..time().."_", "CHANNEL", nil, self:getChanID(GetChannelList()))
							LastSent[v] = time()
						end
					end
					--self:DebugMsg(msg)
					updateText(self, 100)
				break
			end
		end
	end
end

local waittime = 0
local chanchecked = 0
function TI.join(self, elapsed)
  waittime = waittime + elapsed
  if waittime > 1 then
	local id = self:getChanID(GetChannelList())
	if ( id == false ) then 
		--print("no id, joining")
		JoinChannelByName("RCELVA")
		if RegisterAddonMessagePrefix("RCELVA") ~= true then
			print("TIRareCoordinator: Couldn't register AddonPrefix")
		end
		chanchecked = 0
		needStatus = true
		--print("getting status from" .. owner)
		--SendAddonMessage("RCELVA", "GetStatus", "WHISPER", owner)
	else
		--self:SetScript("OnUpdate", nil)
		local channels = GetNumDisplayChannels()
		if channels > chanchecked then
			SetSelectedDisplayChannel(channels - chanchecked)
		end
		chanchecked = chanchecked + 1 

	end	
	waittime = 0
  end
end

local function LockOrUnlock()
	if locked then
		print("TIRareCoordinator is now |cff00ff00unlocked|r. - Type /ti or /tirare to lock it")
		
		TI:EnableMouse(true)
		TI:SetMovable(true)
		TI:SetResizable(true)
		TI:SetScript("OnSizeChanged", onResize)
		TI:SetScript("OnDragStart", onDragStart)
		TI:SetScript("OnDragStop", onDragStop)
		TI:RegisterForDrag("LeftButton")
		TI:Show()
		TI.res:Show()
		
		TI.opt.locked.status:SetText("Frame is |cff00ff00unlocked")
		TI.opt.locked.button:SetText("lock")
		
		locked = false
	else
		print("TIRareCoordinator is now |cffff0000locked|r. - Type /ti or /tirare to lock it")	
		
		TI:SetMovable(false)
		TI:EnableMouse(false)
		TI:SetResizable(false)
		TI:RegisterForDrag()
		TI:SetScript("OnDragStart", nil)
		TI:SetScript("OnDragStop", nil)
		TI:SetScript("OnHide", nil)
		TI:ShowOrHide()
		TI.res:Hide()
		
		TI.opt.locked.status:SetText("Frame is |cffff0000locked")
		TI.opt.locked.button:SetText("unlock")
		
		locked = true
	end
end


function TI:DebugMsg(msg)
	print(msg)
		
end


SLASH_TIRARECOORDINATOR1 = "/tirare"
SLASH_TIRARECOORDINATOR2 = "/tirarecoordinator"
SLASH_TIRARECOORDINATOR3 = "/tirc"
local function SlashHandler(msg, editbox)
	--print("Usage")
	LockOrUnlock()
end
SlashCmdList["TIRARECOORDINATOR"] = SlashHandler;

TI.updater = CreateFrame("Frame", "TI.updater", TI)
TI.updater:SetScript("OnUpdate", updateText)

TI:SetScript("OnEvent", TI.OnEvent)


--ONLY FOR TESTING
--		TI:SetScript("OnUpdate", TI.join)
		
		
TI:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
TI:RegisterEvent("ADDON_LOADED")
TI:RegisterEvent("PLAYER_TARGET_CHANGED")
TI:RegisterEvent("CHAT_MSG_CHANNEL")
TI:RegisterEvent("CHAT_MSG_ADDON")
TI:RegisterEvent("PLAYER_ENTERING_WORLD")
TI:RegisterEvent("ZONE_CHANGED_NEW_AREA")
TI:RegisterEvent("CHANNEL_ROSTER_UPDATE")


TI.opt.locked.button:SetScript("OnClick", function(self) LockOrUnlock() end)

updateText(TI, 100)
onResize(TI, TI:GetWidth(), 0)
TI:Show()
